--    Program: 		CAPAREXT_INVOICE_ADJUST.sql
--    Description:  Extract AR Invoice Adjustment information 
--    Revision:     1st     
--    Parameter: 	1. set of books short name e.g. SOB_C999

set doc off;      
set verify off;
set serveroutput on size 1000000;
whenever sqlerror exit failure rollback;
alter session set nls_date_format='YYYYMMDD HH24:MI:SS';

declare   
   l_processed_count		number;
   l_rejected_count 		number;
   l_err_msg				varchar2(2000);
                    		
   l_utl_file       		utl_file.file_type;
   l_filename       		varchar2(255);
   l_pathname       		varchar2(100);
                    		
   l_ngo_sob				varchar2(20);
   
   l_set_of_books_id		number;
                    		  
   cursor cur_invoice_adjust (p_set_of_books_id number) is
      select * from AR_ADJUSTMENTS_ALL
      where set_of_books_id = p_set_of_books_id;

begin
   l_pathname := '/tmp';
   l_filename := 'CAPAR_INVOICE_ADJUST.dat';
   l_utl_file := utl_file.fopen(l_pathname, l_filename, 'w');
   
   l_processed_count := 0;
   l_rejected_count  := 0;
   
   l_ngo_sob := '&1';
   
   begin
     select set_of_books_id
     into   l_set_of_books_id
     from   gl_sets_of_books
     where  upper(short_name) = upper(l_ngo_sob);
   exception
     when others then
       dbms_output.put_line(l_ngo_sob||': set of books name not found');
       --raise;
   end;      

   for cur in cur_invoice_adjust(l_set_of_books_id) loop   	
     
     -- output data 
     utl_file.put_line( l_utl_file, 
       cur.ADJUSTMENT_ID                   || chr(9) ||
       cur.LAST_UPDATED_BY                 || chr(9) ||
       cur.LAST_UPDATE_DATE                || chr(9) ||
       cur.LAST_UPDATE_LOGIN               || chr(9) ||
       cur.CREATED_BY                      || chr(9) ||
       cur.CREATION_DATE                   || chr(9) ||
       cur.AMOUNT                          || chr(9) ||
       cur.APPLY_DATE                      || chr(9) ||
       cur.GL_DATE                         || chr(9) ||
       cur.SET_OF_BOOKS_ID                 || chr(9) ||
       cur.CODE_COMBINATION_ID             || chr(9) ||
       cur.TYPE                            || chr(9) ||
       cur.ADJUSTMENT_TYPE                 || chr(9) ||
       cur.STATUS                          || chr(9) ||
       cur.LINE_ADJUSTED                   || chr(9) ||
       cur.FREIGHT_ADJUSTED                || chr(9) ||
       cur.TAX_ADJUSTED                    || chr(9) ||
       cur.RECEIVABLES_CHARGES_ADJUSTED    || chr(9) ||
       cur.ASSOCIATED_CASH_RECEIPT_ID      || chr(9) ||
       cur.CHARGEBACK_CUSTOMER_TRX_ID      || chr(9) ||
       cur.BATCH_ID                        || chr(9) ||
       cur.CUSTOMER_TRX_ID                 || chr(9) ||
       cur.CUSTOMER_TRX_LINE_ID            || chr(9) ||
       cur.SUBSEQUENT_TRX_ID               || chr(9) ||
       cur.PAYMENT_SCHEDULE_ID             || chr(9) ||
       cur.RECEIVABLES_TRX_ID              || chr(9) ||
       cur.DISTRIBUTION_SET_ID             || chr(9) ||
       cur.GL_POSTED_DATE                  || chr(9) ||
       cur.COMMENTS                        || chr(9) ||
       cur.AUTOMATICALLY_GENERATED         || chr(9) ||
       cur.CREATED_FROM                    || chr(9) ||
       cur.REASON_CODE                     || chr(9) ||
       cur.POSTABLE                        || chr(9) ||
       cur.APPROVED_BY                     || chr(9) ||
       cur.ATTRIBUTE_CATEGORY              || chr(9) ||
       cur.ATTRIBUTE1                      || chr(9) ||
       cur.ATTRIBUTE2                      || chr(9) ||
       cur.ATTRIBUTE3                      || chr(9) ||
       cur.ATTRIBUTE4                      || chr(9) ||
       cur.ATTRIBUTE5                      || chr(9) ||
       cur.ATTRIBUTE6                      || chr(9) ||
       cur.ATTRIBUTE7                      || chr(9) ||
       cur.ATTRIBUTE8                      || chr(9) ||
       cur.ATTRIBUTE9                      || chr(9) ||
       cur.ATTRIBUTE10                     || chr(9) ||
       cur.POSTING_CONTROL_ID              || chr(9) ||
       cur.ACCTD_AMOUNT                    || chr(9) ||
       cur.ATTRIBUTE11                     || chr(9) ||
       cur.ATTRIBUTE12                     || chr(9) ||
       cur.ATTRIBUTE13                     || chr(9) ||
       cur.ATTRIBUTE14                     || chr(9) ||
       cur.ATTRIBUTE15                     || chr(9) ||
       cur.PROGRAM_APPLICATION_ID          || chr(9) ||
       cur.PROGRAM_ID                      || chr(9) ||
       cur.PROGRAM_UPDATE_DATE             || chr(9) ||
       cur.REQUEST_ID                      || chr(9) ||
       cur.ADJUSTMENT_NUMBER               || chr(9) ||
       cur.ORG_ID                          || chr(9) ||
       cur.USSGL_TRANSACTION_CODE          || chr(9) ||
       cur.USSGL_TRANSACTION_CODE_CONTEXT  || chr(9) ||
       cur.DOC_SEQUENCE_VALUE              || chr(9) ||
       cur.DOC_SEQUENCE_ID                 || chr(9) ||
       cur.ASSOCIATED_APPLICATION_ID       || chr(9) ||
       cur.CONS_INV_ID                     || chr(9) ||
       cur.MRC_GL_POSTED_DATE              || chr(9) ||
       cur.MRC_POSTING_CONTROL_ID          || chr(9) ||
       cur.MRC_ACCTD_AMOUNT                || chr(9) ||
       cur.ADJ_TAX_ACCT_RULE               || chr(9) ||
       cur.GLOBAL_ATTRIBUTE_CATEGORY       || chr(9) ||
       cur.GLOBAL_ATTRIBUTE1               || chr(9) ||
       cur.GLOBAL_ATTRIBUTE2               || chr(9) ||
       cur.GLOBAL_ATTRIBUTE3               || chr(9) ||
       cur.GLOBAL_ATTRIBUTE4               || chr(9) ||
       cur.GLOBAL_ATTRIBUTE5               || chr(9) ||
       cur.GLOBAL_ATTRIBUTE6               || chr(9) ||
       cur.GLOBAL_ATTRIBUTE7               || chr(9) ||
       cur.GLOBAL_ATTRIBUTE8               || chr(9) ||
       cur.GLOBAL_ATTRIBUTE9               || chr(9) ||
       cur.GLOBAL_ATTRIBUTE10              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE11              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE12              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE13              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE14              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE15              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE16              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE17              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE18              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE19              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE20              || chr(9) ||
       cur.LINK_TO_TRX_HIST_ID 
	 );                        
                               
	 l_processed_count := l_processed_count + 1;
   end loop;

   if l_processed_count = 0 then   
     l_rejected_count := l_rejected_count + 1;
     l_err_msg := l_ngo_sob || ': AR Invoice Adjustment not found';
   end if;
   
   -- insert into log table
   insert into capcnv_log ( prog_id,process_date, record_processed,record_rejected,record_extracted,err_msg) 
    values ('CAPAREXT_INVOICE_ADJUST', sysdate, l_processed_count, l_rejected_count, l_processed_count-l_rejected_count, l_err_msg );
   
   commit;

   utl_file.fclose(l_utl_file);
exception 
  when others then
    dbms_output.put_line(sqlerrm);
    rollback;  
end;
/

--exit
